<template>
    <v-app>
        <v-app-bar style="z-index: 100" app>

            <div @click="navigateHome" class="custom-link" style="cursor: pointer;">
                <v-toolbar-title>CustomSlide</v-toolbar-title>
            </div>
            <v-spacer></v-spacer>
            <RunPresentationButton v-if="checkRoutePath($route.path)"/>
            <div v-if="isAuth" class="d-flex align-center">
                <p class="ma-0 pr-2">{{ user.email }}</p>
                <v-btn role="button" aria-label="logout" icon @click="logout">
                    <v-icon>mdi-logout</v-icon>
                </v-btn>
            </div>
            <v-btn v-else role="button" aria-label="login" icon @click="$router.push({ name: 'login' })">
                <v-icon>mdi-login</v-icon>
            </v-btn>
        </v-app-bar>

        <v-main>
            <router-view></router-view>
        </v-main>
    </v-app>
</template>

<script>
import RunPresentationButton from "@/components/RunPresentationButton.vue";
import {
    checkRoutePath,
    getPresentationIdFromPath,
} from "@/services/presentations";

export default {
    components: {
        RunPresentationButton,
    },
    computed: {
        isAuth() {
            return this.$store.getters['user/isAuth'];
        },
        user() {
            return this.$store.getters['user/user'];
        }
    },
    methods: {
        checkRoutePath,
        getPresentationIdFromPath,
        async logout() {
            try {
                await this.$store.dispatch('user/logout');
                await this.$router.push({ name: 'home' });
            } catch (e) {
                console.error(e);
            }
        },
        navigateHome() {
            this.$router.push({ name: 'home' });
        }
    },
};
</script>

<style>
.custom-link:link,
.custom-link:visited {
    text-decoration: none;
    color: black;
}
</style>
